use simcore_rs::{channel, simulation};

fn main() {
	simulation(
		(),
		|sim| sim.process(async move {
			println!("[{}] Begin", sim.now());
			
			let (sx, rx) = channel();
			sim.activate(async move {
				for i in 0.. {
					sim.advance(1.0).await;
					sx.send(i).await.ok();
				}
			});
			
			sim.select(async move {
				while let Some(i) = rx.recv().await {
					println!("[{}] Received {}", sim.now(), i);
					if i >= 3 { break; }
				}
				
				println!("[{}] Exit Receiver Process", sim.now());
			}, sim.advance(5.0)).await;
			
			sim.advance(10.0).await;
			println!("[{}] End", sim.now());
		})
	);
}
